
# this is part of a larger perl script, which writes a cl script
#filesm is a file with the list of input files, 2 or more

# cosmic ray detection
#high is the number of sigma above which is a cosmic ray
# this is the only free parameter, set by experiment
$high=20.0;

# make temporary median file
print OUT1 ("imdel $med ver- \n");
if($size > 2){
print OUT1 ("imcombine \@$filesm $med comb=median scale=none\n");
}
else
{
print OUT1 ("imcombine \@$filesm $med comb=average reject=minmax nhigh=1 nlow=0 scale=none\n");
}
# make variance file
print OUT1 ("imfunct $med $med func=sqrt ver- \n");
print OUT1 ("imarith $med * 1.4 $med  \n");
print OUT1 ("imrepl $med value=5 upper=5 \n");
# now call cosmic program to find cosmics and interpolate
print OUT1 ("!perl ~/programs/cosmic.pl $filesm $high $med \n");
print OUT1 ("imdel $med ver- \n");

(end of this part)
-----------------------------------------
### cosmic.pl


#this perl script makes another cl script called cosmic.cl

#!/usr/bin/perl 
# note, you have to change above line
#  $high is the cosmic ray detection limit
if($#ARGV != 2){
print (" missing argument, enter file name with list \n"); 
exit}
$imagel=$ARGV[0];
$high=$ARGV[1];
$med=$ARGV[2];
open(in1, "$imagel") || die "Can't open $imagel $!";
open (OUT, ">cosmic.cl") || die "Can't open output file $!";
$cwd=  $ENV{"PWD"};
print OUT ("cd $cwd \n");
print OUT ("cd $cwd \n");
$iff=0;
print OUT ("imred \n");
print OUT ("ccdred \n");
print OUT ("crutil \n");  
print OUT ("set uparm=/home/caldwell/programs/uparm/ \n");
#       $namem1=$name1 . "_m.pl";

# print OUT ("imdel  $namem1 ver- \n");  

# for the first 2 images, cosmics are found in both at once
# for subsequent images, cosmics are found in the new image
# e.g., first #1 vs #2 gets both cosmics, then #2 vs #3 gets cosmics for #3

$iff=0;
while ($line2=<in1>){
chomp($line2);
($name,$junk)=split '.fit', $line2;
$namef=$name . ".fits";
$ifbin=`gethead $namef NAXIS1`;
chomp($ifbin);
$namei=$name . ".imh";
$namepl=$name . "_mask";
$namepli=$name . "_mask.pl";
$nameplf=$namepl . ".imh";
if($iff==0){
    $line2=<in1>;
chomp($line2);
($name2,$junk)=split '.fit', $line2;
# print ("$name $name2 \n");
$name2f=$name2 . ".fits";
$name2i=$name2 . ".imh";
$namepl2=$name2 . "_mask";
$namepl2i=$name2 . "_mask.pl";
$nameplf2=$namepl2 . ".imh";
print OUT ("imcopy $name $namei \n");
print OUT ("imcopy $name2 $name2i \n");
# this calls an imfort program that finds the cosmics
print OUT ( "!~/programs/cosmic.e $name $name2 $namepl $namepl2 0 $high $med \n");
# fix up the mask files
print OUT ("imdel $namepli,$namepl2i ver- \n");
print OUT ("imcopy $namepl $namepli \n");
print OUT ("imcopy $namepl2 $namepl2i \n");
print OUT ("crgrow $namepli $namepli radius=1.5 \n");  
print OUT ("crgrow $namepl2i $namepl2i radius=1.5 \n");  
print OUT ("hedit $namef BPM $namepli add+ \n");  
print OUT ("hedit $name2f BPM $namepl2i add+ \n");  
#different binnings require some header fixes
if($ifbin>2048){
print OUT ("hedit $namef ccdsec '[1:4096,1:4608]' \n");  
print OUT ("hedit $name2f ccdsec '[1:4096,1:4608]' \n");  
}
if($ifbin==2048){
print OUT ("hedit $namef ccdsec '[1:2048,1:1536]' \n");  
print OUT ("hedit $name2f ccdsec '[1:2048,1:1536]' \n");  
}

# we want to do ccdproc again, so delete the fixpix keywords
print OUT ("hedit $namef FIXPIX del+ \n");  
print OUT ("hedit $name2f FIXPIX del+ \n");  
#now run ccdproc again, interpolation along columns 
print OUT ("ccdproc $namef,$name2f fixp+ zeroc- darkc- flatc- fixf=BPM \n");
print OUT ("imdel $namei,$nameplf,$nameplf2 ver- \n");
$iff=1;
}
else
{
#call cosmic once
$nameplf2=$namepl2 . ".imh";
print OUT ("imcopy $name $namei \n");
print OUT ( "!~/programs/cosmic.e $name $name2 $namepl $namepl2 1 $high $med \n");
print OUT ("imdel $namepli ver- \n");
print OUT ("imcopy $namepl $namepli \n");
print OUT ("crgrow $namepli $namepli radius=1.5 \n");  
print OUT ("hedit $namef BPM $namepli add+ \n");  
if($ifbin>2048){
print OUT ("hedit $namef ccdsec '[1:4096,1:4608]' \n");  
}
if($ifbin==2048){
print OUT ("hedit $namef ccdsec '[1:2048,1:1536]' \n");  
}
print OUT ("hedit $namef FIXPIX del+ \n");  
print OUT ("ccdproc $namef fixp+ zeroc- darkc- flatc- fixf=BPM \n");
print OUT ("imdel $name2i,$nameplf,$nameplf2 ver- \n");
$name2=$name;
$name2i=$namei;
$namepl2=$namepl;
}

}
print OUT ("imdel $name2i ver- \n");
print OUT ("logout \n");
close (OUT);

close (in1);
system "cd \n";
$place= $cwd . "/cosmic.cl";
$log="/tmp/log.cosmic." . $imagel;
system "cd; cl < $place >& $log \n";
