# HLIGHTFIX -- Interpolate across light leak
# By Doug Mink, SAO/TDC
# November 20, 2007

procedure hlightfix (images)

string	images = ""	{prompt="Input multispec images to correct"}
bool deltemp = no	{prompt="Delete temporary files (y or n)"}
bool saveold = yes	{prompt="Save unprocessed files to Nofix/ (y or n)"}
bool verbose = yes	{prompt="Log progress (y or n)"}
bool debug = no		{prompt="Log each aperture (y or n)"}

begin
	bool vb, db, del, save
	string	imtype, mstype, keyroot, apxkey, apykey, rratio, aps
	file imin, imout, geores, geotemp, imroot, newfile, templist
	string imageap, history, order, function, ims, tchar
	int index, iap, nap, npix, lroot, xcol, ycol
	real x, y, rad, ratio

	ims = images
	del = deltemp
	save = saveold
	vb = verbose
	db = debug

# Set up sumspec
	if (!defpac ("rvsao"))
	    rvsao (motd=no)
	sumspec.specnum = ""
	sumspec.specband = 0
	sumspec.specdir = ""
	sumspec.compname = ""
	sumspec.compdir = "lightfix/"
	sumspec.nspec = 1
	sumspec.save_names = no
	sumspec.copy_header = yes
	sumspec.normin = 0.
	sumspec.fixbad = "yes"
	sumspec.badlines = "lightleak.dat"
	sumspec.linedir = "hectospec$"
	sumspec.cont_remove = "no"
	sumspec.cont_split = 1
	sumspec.reject = no
	sumspec.abs_reject = 100.
	sumspec.em_reject = 2.
	sumspec.contout = "no"
	sumspec.cont_plot = no
	sumspec.cont_add = 0.
	sumspec.spec_smooth = 0
	sumspec.st_lambda = INDEF
	sumspec.end_lambda = INDEF
	sumspec.pix_lambda = INDEF
	sumspec.npts = INDEF
	sumspec.complog = no
	sumspec.interp_mode = "linear"
	sumspec.normout = 0.
	sumspec.spec_plot = no
	sumspec.spec_int = no
	sumspec.comp_plot = no
	sumspec.comp_int = no
	sumspec.ymin = 0.
	sumspec.ymax = 2.
	sumspec.velcomp = INDEF
	sumspec.zcomp = INDEF
	sumspec.svel_corr = "none"
	sumspec.nsmooth = 0
	sumspec.device = "stdgraph"
	sumspec.plotter = "stdplot"
	sumspec.logfiles = "STDOUT,displin.log"
	sumspec.nsum = 1
	sumspec.debug = no
	

#  Make temporary list of input files
	tchar = substr (ims,1,1)
        if (tchar == '@') {
	    templist = substr (ims,2,100)
	    deltemp = no
	    }
	else {
	    templist = mktemp ("geolist")
	    files (ims, >templist)
	    }
	list = templist
	while (fscan (list,imin) != EOF) {

	    sumspec (imin, compfile=imin)

	    }

	if (deltemp) {
	    delete (templist)
	    }
end

# Nov 20 2007	New task
