# HMERGE - Combine 4 amps into one Hectospec image or two Hectochelle images
# February 22, 2008
# By Doug Mink, SAO Telescope Data Center

procedure hmerge (images)

string	images=""	{prompt="Image file(s) to merge"}

bool	perchip=yes	{prompt="Merge amps to one output file per CCD (y or n)"}
bool	saveold=yes	{prompt="Save unmerged files in Unmerged/ (y or n)"}
bool	deltemp=yes	{prompt="Delete intermediate image files (y or n)"}
bool	verbose=yes	{prompt="Print process progress (y or n)"}

struct	*mergelist

begin

file	imroot, temp1, temp2, temp3, temp4, im4, imin, templist, imout
file	imfile, newfile, imex0
string	amp1, amp2, amp3, amp4, arg1, imx, ims, history
string	gain1, gain2, gain3, gain4
bool	dellist, vb, perc, sv, dt

	vb = verbose
	sv = saveold
	dt = deltemp
	imx = ".fits"
	ims = images
	perc = perchip

	if (ims == "") {
	    print ("HMERGE: Combine 4 amps on chips from 1 Hectospec image or 2 Hectochelle images")
	    print ("Usage: hmerge <input image with 4 extensions>")
	    return
	    }

	hedit.add = no
	hedit.addonly = no
	hedit.delete = no
	hedit.verify = no
	hedit.show = no
	hedit.update = yes

#  Make temporary list of input files
        templist = mktemp ("tempmerge") // ".list"
        files (ims, >templist)

# Merge files from list
        mergelist = templist
        while (fscan (mergelist, imin) != EOF) {
	    hmerge1 (imin,perchip=perc,saveold=sv,deltemp=dt,verbose=vb)
	    }

	if (deltemp)
	    delete (templist)
	mergelist = ""
end

# Jun 22 2004	Program to make a images from four amplifier image extensions
# Sep  2 2004	Do not process image if HMERGE keyword already exists
# Sep  2 2004	Merge multiple files
# Oct 13 2004	Check for HMERGE in 0th extension (only extension if processed)
# Oct 18 2004	Print HMERGE value if amplifiers are already merged
# Dec 21 2004	Add option to merge amplifiers on each chip and write two files

# Jan 13 2005	Change per-chip suffixes from _1 and _2 to _chip1 and _chip2
# Mar 17 2005	Do not reset deltemp if input from file list
# Aug 31 2005	Set all hedit parameters

# Feb 20 2008	Read files from mergelist instead of list
# Feb 22 2008	Move actual merging to HMERGE1
