# MAKENORM -- Make a pixel-to-pixel variation multispec correction file
# By Doug Mink, SAO
# June 14, 2004

procedure makenorm (input, output)

string	input = ""	{prompt="Input multispec image from which to make a correction file"}
string	output = "pixnorm.ms.fits"	{prompt="Output multispec correction file"}
string function = "spline3"	{prompt="Function for spectrum fit"}
int  order = 70		{prompt="Order of spectrum fit"}
bool deltemp = yes	{prompt="Delete temporary files (y or n)"}
bool verbose = no	{prompt="Log each aperture (y or n)"}

begin
	string	imtype, mstype, keyroot, apxkey, apykey, rratio
	file imin, imout, imrad
	string imageap
	int iext, index, iap, nap, npix
	real x, y, rad, ratio
	bool vb

	vb = verbose
	imin = input
	imout = output
	iext = stridx (".ms", imin)
	if (iext < 1) {
	    print "MAKENORM: ", imin, " must be a multispec file"
	    return
	    }
	if (imout == "") {
	    imout = substr (imin,1,iext-1)
	    imout = imout // "tc.ms.fits"
	    }
	if (vb) {
	    print ("MAKENORM: ", imin, " => ", imout)
	    }

# Fit each spectrum with high order fit
	rvsao(motd=no)
	imgetp (imin, "i_naxis1", verbose=vb)
	sumspec.npts = int (imgetp.value)
	sumspec.st_lambda = 1.0
	sumspec.pix_lambda = 1.0
	sumspec.end_lambda = real (imgetp.value)
	sumspec.comp_plot = yes
	sumspec.fixbad = "no"
	sumspec.specnum = "1-300"
	sumspec.nspec = 300
	sumspec.specband = 0
	sumspec.specdir = ""
	sumspec.compname = ""
	sumspec.compdir = ""
	sumspec.save_names = no
	sumspec.normin = 0.
	sumspec.fixbad = "no"
	sumspec.cont_split = 1
	sumspec.reject = no
	sumspec.abs_reject = 10.
	sumspec.em_reject = 10.
	sumspec.cont_add = 0.
	sumspec.spec_smooth = 0
	sumspec.complog = no
	sumspec.interp_mode = "spline3"
	sumspec.normout = 0.
	sumspec.spec_plot = no
	sumspec.spec_int = no
	sumspec.comp_int = no
	sumspec.velcomp = INDEF
	sumspec.zcomp = INDEF
	sumspec.svel_corr = "none"
	sumspec.nsmooth = 0
	sumspec.device = "stdgraph"
	sumspec.plotter = "stdplot"
	sumspec.logfiles = "STDOUT,sumspec.log"
	sumspec.nsum = 1
	sumspec.debug = no
	sumspec.cursor = ""
	contsum.c_interactive = no
	contsum.c_sample = "*"
	contsum.c_function = function
	contsum.naverage = 1
	contsum.order = order
	contsum.s_low_reject = 3.
	contsum.s_high_reject = 4.
	contsum.niterate = 10
	contsum.grow = 1.
	sumspec (imin, imout, cont_remove="no", cont_plot=vb, contout="divide")
end
# Jun 14 2004	Change name from makenorm1 to makenorm
