# File hectosepc/Src/hskysort.x
# July 9, 2008
# Modified by Doug Mink from IRAF sys/etc/gqsort.x
# Copyright(c) 1986 Association of Universities for Research in Astronomy Inc.

define	LOGPTR 	32			# log2(maxpts)  (4e9)

# HSKYSORT -- General quicksort for arbitrary objects.  X is an integer array
# indexing the array to be sorted.

procedure hskysort (x, nelem, dist)

int	x[ARB]		#U array to be sorted
int	nelem		#I number of elements in array
double  dist[ARB]	# table of distances between object and sky

int	i, j, k, lv[LOGPTR], p, pivot, uv[LOGPTR], temp
define	swap {temp=$1;$1=$2;$2=temp}

begin
	lv[1] = 1
	uv[1] = nelem
	p = 1

	while (p > 0) {
	    if (lv[p] >= uv[p])			# only one elem in this subset
		p = p - 1			# pop stack
	    else {
		# Dummy loop to trigger the optimizer.
		do p = p, ARB {
		    i = lv[p] - 1
		    j = uv[p]

		    # Select as the pivot the element at the center of the
		    # subfile, to avoid quadratic behavior on an already
		    # sorted list.

		    k = (lv[p] + uv[p]) / 2
		    swap (x[j], x[k])
		    pivot = x[j]			# pivot line

		    while (i < j) {
			for (i=i+1;  dist[x[i]] < dist[pivot];  i=i+1)
			    ;
			for (j=j-1;  j > i;  j=j-1)
			    if (dist[x[j]] <= dist[pivot])
				break
			if (i < j)			# out of order pair
			    swap (x[i], x[j])	# interchange elements
		    }

		    j = uv[p]			# move pivot to position i
		    swap (x[i], x[j])		# interchange elements

		    if (i-lv[p] < uv[p] - i) {	# stack so shorter done first
			lv[p+1] = lv[p]
			uv[p+1] = i - 1
			lv[p] = i + 1
		    } else {
			lv[p+1] = i + 1
			uv[p+1] = uv[p]
			uv[p] = i - 1
		    }

		    break
		}

		p = p + 1			# push onto stack
	    }
	}
end

# Jul  9 2008	New subroutine without passed computation routine
